package com.winhc.bigdata.udf;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.udf.UDF;
import com.winhc.bigdata.utils.CompanyUtils;
import org.apache.commons.lang3.StringUtils;

import java.util.*;
import java.util.stream.Collectors;

import static com.winhc.bigdata.utils.CompanyUtils.cleanup;

/**
 * @Author: π
 * @Description: 历史名称比较名称包含
 */
public class name_compare_v2 extends UDF {


    public List<String> yhcNames(String names) {
        Set<String> set = new HashSet<>();

        if (org.apache.commons.lang3.StringUtils.isNotBlank(names)) {
            set.addAll(Arrays.stream(names.split("\t;\t"))
                    .filter(org.apache.commons.lang3.StringUtils::isNotBlank).collect(Collectors.toSet()));
        }
        return set.stream()
                .filter(org.apache.commons.lang3.StringUtils::isNotBlank)
                .map(x -> x.replaceAll("\t;", "")
                        .replaceAll("[（]", "(")
                        .replaceAll("[）]", ")")
                        .trim())
                .map(CompanyUtils::cleanup)
                .filter(org.apache.commons.lang3.StringUtils::isNotBlank)
                .distinct()
                .collect(Collectors.toList());
    }
    public List<String> qxbNames(String names) {
        Set<String> set = new HashSet<>();

        if (org.apache.commons.lang3.StringUtils.isBlank(names)) {
            return new ArrayList<>(set);
        }
        String[] split = names.replaceAll("\\[", "").replaceAll("\\]", "").split(", ");

        if(split.length>0){
            List<String> tt_res = Arrays.stream(split)
                    .filter(StringUtils::isNotBlank)
                    .map(CompanyUtils::cleanup)
                    .filter(StringUtils::isNotBlank)
                    .distinct().collect(Collectors.toList());
            set.addAll(tt_res);
        }
        return new ArrayList<>(set);
    }
    public String evaluate(String names_yhc, String names_qxb) {
        List<String> list1 = yhcNames(names_yhc);
        List<String> list2 = qxbNames(names_qxb);

        return compare(list1, list2);
    }

    private static String compare(List<String> name1, List<String> name2) {

        if (name1.size() != name2.size()) {
            return "1";
        }

        List<String> reduce1 = name1.stream().filter(item -> !name2.contains(item)).collect(Collectors.toList());

        List<String> reduce2 = name2.stream().filter(item -> !name1.contains(item)).collect(Collectors.toList());


        if (reduce1.size() > 0 || reduce2.size() > 0) {
            return "1";
        }

        return "0";
    }



    public static void main(String[] args) {

        name_compare_v2 v1 = new name_compare_v2();
        String evaluate = v1.evaluate("陕西圆周率文教科技有限公司\t;\t西安风韵艺术文化传播有限公司", "[西安风韵艺术文化传播有限公司, 陕西圆周率文教科技有限公司1]");
        String evaluate1 = v1.evaluate("高通盛融（北京）投资基金管理有限公司", "[高通盛融（北京）投资基金管理有限公司]");
        System.out.println(evaluate);
        System.out.println(evaluate1);

    }
}
