package com.winhc.bigdata.udtf.judgment_doc;

import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.udf.UDFException;
import com.aliyun.odps.udf.UDTF;
import com.aliyun.odps.udf.annotation.Resolve;
import com.winhc.bigdata.udtf.judgment_doc.entity.EsCompanyBaseCaseEntity;
import com.winhc.bigdata.udtf.judgment_doc.utils.JudgmentDocumentUtils;

import java.io.IOException;
import java.util.List;

/**
 * @Author: XuJiakai
 * 2024/6/5 11:02
 */
@Resolve(value = "*->string")
public class CompanyCaseUDTF  extends UDTF {
    @Override
    public void process(Object[] objects) throws UDFException, IOException {
        String str = (String) objects[0];

        JSONObject jsonObject = JSONObject.parseObject(str);
        List<EsCompanyBaseCaseEntity> esCompanyCaseData = JudgmentDocumentUtils.getEsCompanyCaseData(jsonObject);

        for (EsCompanyBaseCaseEntity esCompanyCaseDatum : esCompanyCaseData) {
            forward(esCompanyCaseDatum.toEsIndexJsonStr());
        }
    }
}
