package com.winhc.bigdata.udtf.judgment_doc;

import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.data.SimpleStruct;
import com.aliyun.odps.data.Struct;
import com.aliyun.odps.udf.UDFException;
import com.aliyun.odps.udf.UDTF;
import com.aliyun.odps.udf.annotation.Resolve;
import com.winhc.bigdata.udtf.judgment_doc.entity.EsLawyerBaseCaseEntity;
import com.winhc.bigdata.udtf.judgment_doc.utils.JudgmentDocumentUtils;

import java.io.IOException;
import java.util.List;

/**
 * @Author: XuJiakai
 * 2024/6/5 11:02
 */
@Resolve(value = "*->string")
public class LawyerCaseUDTF extends UDTF {
    @Override
    public void process(Object[] objects) throws UDFException, IOException {
        String str = (String) objects[0];

        JSONObject jsonObject = JSONObject.parseObject(str);
        List<EsLawyerBaseCaseEntity> esLawyerCaseData = JudgmentDocumentUtils.getEsLawyerCaseData(jsonObject);

        for (EsLawyerBaseCaseEntity esLawyerCaseDatum : esLawyerCaseData) {
            forward(esLawyerCaseDatum.toEsIndexJsonStr());
        }
    }
}
