package com.winhc.bigdata.udtf.judgment_doc.entity;

import cn.hutool.core.bean.DynaBean;
import cn.hutool.core.util.ReflectUtil;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.SneakyThrows;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.util.List;

import com.winhc.bigdata.utils.BaseUtils;
/**
 * @Author: XuJiakai
 * 2024/5/22 16:28
 * company_case和lawyer_case抽象出案件的通用信息
 */
@Getter
@Setter
@NoArgsConstructor
public class BaseCaseInfo implements Serializable {
    private String case_id;
    private String case_type;
    private String case_reason_level1;
    private String case_reason_level2;
    private String case_reason_level3;
    private String case_reason_level4;
    private String case_reason;
    private String case_reason_levelnum;
    private String case_stage;
    private BigDecimal case_amt;
    private BigDecimal judge_amt;
    private BigDecimal accept_amt;
    private String province_court_name;
    private String city_court_name;
    private String court_name;
    private String court_province_code;
    private String court_city_code;

    private String court_level;
    private List<String> judge_name;

    private String judge_date;

    private String create_time;
    private String update_time;
    private Integer deleted;


    @Override
    public String toString() {
        return BaseUtils.toString(this, SerializerFeature.WriteDateUseDateFormat);
    }


    @SneakyThrows
    public EsCompanyBaseCaseEntity toEsCompanyCaseEntity() {
        EsCompanyBaseCaseEntity entity = new EsCompanyBaseCaseEntity();
        DynaBean target = DynaBean.create(entity);
        Field[] fields = ReflectUtil.getFields(BaseCaseInfo.class);
        for (Field field : fields) {
            String field_name = field.getName();
            Object value = field.get(this);
            target.set(field_name, value);
        }
        return entity;
    }


    @SneakyThrows
    public EsLawyerBaseCaseEntity toEsLawyerCaseEntity() {
        EsLawyerBaseCaseEntity entity = new EsLawyerBaseCaseEntity();
        DynaBean target = DynaBean.create(entity);
        Field[] fields = ReflectUtil.getFields(BaseCaseInfo.class);
        for (Field field : fields) {
            String field_name = field.getName();
            Object value = field.get(this);
            target.set(field_name, value);
        }
        return entity;
    }


    public String getIndexName() {
        throw new RuntimeException("Method not implemented! ");
    }


    public String get_id() {
        throw new RuntimeException("Method not implemented! ");
    }


    public String toEsIndexJsonStr() {
        JSONObject jsonObject = ((JSONObject) JSONObject.toJSON(this));

        return BaseUtils.toString(jsonObject);
    }
}
