package com.winhc.bigdata.udtf.judgment_doc.entity;


import com.alibaba.fastjson.JSONObject;
import com.winhc.bigdata.utils.BaseUtils;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

import java.math.BigDecimal;
import java.util.List;

/**
 * @Author: XuJiakai
 * 2024/5/22 10:24
 */
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor(staticName = "of")
public class JudgmentDocumentSummaryEntity {

    private String base_lawyer_id;
    private String rowkey;
    private List<String> case_reason_std;

    private String court_name;
    private String case_amt;
    private List<String> company_id;

    public String getPrimaryKey() {
        return base_lawyer_id + "_" + rowkey;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o == null || getClass() != o.getClass()) return false;

        JudgmentDocumentSummaryEntity that = (JudgmentDocumentSummaryEntity) o;

        return new EqualsBuilder().append(base_lawyer_id, that.base_lawyer_id).append(rowkey, that.rowkey).append(case_reason_std, that.case_reason_std).append(court_name, that.court_name).append(case_amt, that.case_amt).append(company_id, that.company_id).isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37).append(base_lawyer_id).append(rowkey).append(case_reason_std).append(court_name).append(case_amt).append(company_id).toHashCode();
    }

    @Override
    public String toString() {
        return BaseUtils.toString(this);
    }

    public JSONObject toJSONObject() {
        return ((JSONObject) JSONObject.toJSON(this));
    }
}
